<?xml version="1.0" encoding="UTF-8"?>

<!-- NOTE This tgextra-write.wsdl file is ment to be used for WRITE ACCESS 
	to any TextGrid RBAC installation. For read only access please use tgextra.wsdl, 
	for communication with TG-crud use tgextra-crud.wsdl -->

<wsdl:definitions xmlns:soap="http://schemas.xmlsoap.org/wsdl/soap/"
	xmlns:tns="http://textgrid.info/namespaces/middleware/tgauth-write"
	xmlns:wsdl="http://schemas.xmlsoap.org/wsdl/" xmlns:xsd="http://www.w3.org/2001/XMLSchema"
	name="tgextra-write" targetNamespace="http://textgrid.info/namespaces/middleware/tgauth-write">

	<!-- ################################################################### -->
	<!-- ## Typ-Definitionen -->
	<!-- ################################################################### -->

	<wsdl:types>
		<xsd:schema targetNamespace="http://textgrid.info/namespaces/middleware/tgauth-write">
			<xsd:element name="authenticateRequest">
				<xsd:complexType>
					<xsd:sequence>
						<xsd:element name="username" type="xsd:string"
							minOccurs="1" maxOccurs="1" />
						<xsd:element name="password" type="xsd:string"
							minOccurs="1" maxOccurs="1" />
						<xsd:element name="log" type="xsd:string" minOccurs="0"
							maxOccurs="1" />
					</xsd:sequence>
				</xsd:complexType>
			</xsd:element>
			<xsd:element name="authenticateResponse">
				<xsd:complexType>
					<xsd:sequence>
						<xsd:element name="auth" type="xsd:string" minOccurs="1"
							maxOccurs="1" />
					</xsd:sequence>
				</xsd:complexType>
			</xsd:element>
			<xsd:element name="createProjectRequest">
				<xsd:complexType>
					<xsd:sequence>
						<xsd:element name="auth" type="xsd:string" minOccurs="0"
							maxOccurs="1" />
						<xsd:element name="log" type="xsd:string" minOccurs="0"
							maxOccurs="1" />
						<xsd:element name="name" type="xsd:string" minOccurs="1"
							maxOccurs="1" />
						<xsd:element name="description" type="xsd:string"
							minOccurs="0" maxOccurs="1" />
						<xsd:element name="file" type="xsd:string" minOccurs="0"
							maxOccurs="1" />
					</xsd:sequence>
				</xsd:complexType>
			</xsd:element>
			<xsd:element name="createProjectResponse">
				<xsd:complexType>
					<xsd:sequence>
						<xsd:element name="projectId" type="xsd:string"
							minOccurs="1" maxOccurs="1" />
					</xsd:sequence>
				</xsd:complexType>
			</xsd:element>
			<xsd:element name="addMemberRequest">
				<xsd:complexType>
					<xsd:sequence>
						<xsd:element name="auth" type="xsd:string" minOccurs="1"
							maxOccurs="1" />
						<xsd:element name="log" type="xsd:string" minOccurs="0"
							maxOccurs="1" />
						<xsd:element name="username" type="xsd:string"
							minOccurs="1" maxOccurs="1" />
						<xsd:element name="role" type="xsd:string" minOccurs="1"
							maxOccurs="1" />
					</xsd:sequence>
				</xsd:complexType>
			</xsd:element>
			<xsd:element name="deleteMemberRequest">
				<xsd:complexType>
					<xsd:sequence>
						<xsd:element name="auth" type="xsd:string" minOccurs="1"
							maxOccurs="1" />
						<xsd:element name="log" type="xsd:string" minOccurs="0"
							maxOccurs="1" />
						<xsd:element name="username" type="xsd:string"
							minOccurs="1" maxOccurs="1" />
						<xsd:element name="role" type="xsd:string" minOccurs="1"
							maxOccurs="1" />
					</xsd:sequence>
				</xsd:complexType>
			</xsd:element>
			<xsd:element name="setMyUserAttributesRequest">
				<xsd:complexType>
					<xsd:sequence>
						<xsd:element name="auth" type="xsd:string" minOccurs="1"
							maxOccurs="1" />
						<xsd:element name="webAuthSecret" type="xsd:string"
							minOccurs="1" maxOccurs="1" />
						<xsd:element name="attribute" type="tns:userAttribute"
							minOccurs="0" maxOccurs="unbounded" />
					</xsd:sequence>
				</xsd:complexType>
			</xsd:element>
			<xsd:element name="tgAddActiveRoleRequest">
				<xsd:complexType>
					<xsd:sequence>
						<xsd:element name="auth" type="xsd:string" minOccurs="1"
							maxOccurs="1" />
						<xsd:element name="log" type="xsd:string" minOccurs="0"
							maxOccurs="1" />
						<xsd:element name="role" type="xsd:string" minOccurs="1"
							maxOccurs="1" />
					</xsd:sequence>
				</xsd:complexType>
			</xsd:element>
			<xsd:element name="tgDropActiveRoleRequest">
				<xsd:complexType>
					<xsd:sequence>
						<xsd:element name="auth" type="xsd:string" minOccurs="1"
							maxOccurs="1" />
						<xsd:element name="log" type="xsd:string" minOccurs="0"
							maxOccurs="1" />
						<xsd:element name="role" type="xsd:string" minOccurs="1"
							maxOccurs="1" />
					</xsd:sequence>
				</xsd:complexType>
			</xsd:element>
			<xsd:element name="tgGrantPermissionRequest">
				<xsd:complexType>
					<xsd:sequence>
						<xsd:element name="auth" type="xsd:string" minOccurs="1"
							maxOccurs="1" />
						<xsd:element name="log" type="xsd:string" minOccurs="0"
							maxOccurs="1" />
						<xsd:element name="role" type="xsd:string" minOccurs="1"
							maxOccurs="1" />
						<xsd:element name="operation" type="xsd:string"
							minOccurs="1" maxOccurs="1" />
						<xsd:element name="resource" type="xsd:string"
							minOccurs="1" maxOccurs="1" />
					</xsd:sequence>
				</xsd:complexType>
			</xsd:element>
			<xsd:element name="tgRevokePermissionRequest">
				<xsd:complexType>
					<xsd:sequence>
						<xsd:element name="auth" type="xsd:string" minOccurs="1"
							maxOccurs="1" />
						<xsd:element name="log" type="xsd:string" minOccurs="0"
							maxOccurs="1" />
						<xsd:element name="role" type="xsd:string" minOccurs="1"
							maxOccurs="1" />
						<xsd:element name="operation" type="xsd:string"
							minOccurs="1" maxOccurs="1" />
						<xsd:element name="resource" type="xsd:string"
							minOccurs="1" maxOccurs="1" />
					</xsd:sequence>
				</xsd:complexType>
			</xsd:element>
			<xsd:element name="setProjectFileRequest">
				<xsd:complexType>
					<xsd:sequence>
						<xsd:element name="auth" type="xsd:string" minOccurs="1"
							maxOccurs="1" />
						<xsd:element name="log" type="xsd:string" minOccurs="0"
							maxOccurs="1" />
						<xsd:element name="project" type="xsd:string"
							minOccurs="1" maxOccurs="1" />
						<xsd:element name="file" type="xsd:string" minOccurs="1"
							maxOccurs="1" />
					</xsd:sequence>
				</xsd:complexType>
			</xsd:element>
			<xsd:element name="setNameRequest">
				<xsd:complexType>
					<xsd:sequence>
						<xsd:element name="auth" type="xsd:string" minOccurs="1"
							maxOccurs="1" />
						<xsd:element name="log" type="xsd:string" minOccurs="0"
							maxOccurs="1" />
						<xsd:element name="webAuthSecret" type="xsd:string"
							minOccurs="0" maxOccurs="1" />
						<xsd:element name="name" type="xsd:string" minOccurs="1"
							maxOccurs="1" />
						<xsd:element name="mail" type="xsd:string" minOccurs="1"
							maxOccurs="1" />
						<xsd:element name="organisation" type="xsd:string"
							minOccurs="1" maxOccurs="1" />
						<xsd:element name="agreeSearch" type="xsd:boolean"
							minOccurs="1" maxOccurs="1" />
					</xsd:sequence>
				</xsd:complexType>
			</xsd:element>
			<xsd:element name="deactivateProjectRequest">
				<xsd:complexType>
					<xsd:sequence>
						<xsd:element name="auth" type="xsd:string" minOccurs="1"
							maxOccurs="1" />
						<xsd:element name="log" type="xsd:string" minOccurs="0"
							maxOccurs="1" />
						<xsd:element name="project" type="xsd:string"
							minOccurs="1" maxOccurs="1" />
					</xsd:sequence>
				</xsd:complexType>
			</xsd:element>
			<xsd:element name="reactivateProjectRequest">
				<xsd:complexType>
					<xsd:sequence>
						<xsd:element name="auth" type="xsd:string" minOccurs="1"
							maxOccurs="1" />
						<xsd:element name="log" type="xsd:string" minOccurs="0"
							maxOccurs="1" />
						<xsd:element name="project" type="xsd:string"
							minOccurs="1" maxOccurs="1" />
					</xsd:sequence>
				</xsd:complexType>
			</xsd:element>
			<xsd:element name="deleteProjectRequest">
				<xsd:complexType>
					<xsd:sequence>
						<xsd:element name="auth" type="xsd:string" minOccurs="1"
							maxOccurs="1" />
						<xsd:element name="log" type="xsd:string" minOccurs="0"
							maxOccurs="1" />
						<xsd:element name="project" type="xsd:string"
							minOccurs="1" maxOccurs="1" />
					</xsd:sequence>
				</xsd:complexType>
			</xsd:element>
			<xsd:element name="filterResponse">
				<xsd:complexType>
					<xsd:sequence>
						<xsd:element name="resource" type="xsd:string"
							minOccurs="0" maxOccurs="unbounded" />
					</xsd:sequence>
				</xsd:complexType>
			</xsd:element>
			<xsd:element name="booleanResponse">
				<xsd:complexType>
					<xsd:sequence>
						<xsd:element name="result" type="xsd:boolean"
							minOccurs="1" maxOccurs="1" />
					</xsd:sequence>
				</xsd:complexType>
			</xsd:element>
			<xsd:element name="rolesetResponse">
				<xsd:complexType>
					<xsd:sequence>
						<xsd:element name="role" type="xsd:string" minOccurs="0"
							maxOccurs="unbounded" />
					</xsd:sequence>
				</xsd:complexType>
			</xsd:element>
			<xsd:element name="usersetResponse">
				<xsd:complexType>
					<xsd:sequence>
						<xsd:element name="username" type="xsd:string"
							minOccurs="0" maxOccurs="unbounded" />
					</xsd:sequence>
				</xsd:complexType>
			</xsd:element>
			<xsd:element name="resourcesetResponse">
				<xsd:complexType>
					<xsd:sequence>
						<xsd:element name="resource" type="xsd:string"
							minOccurs="0" maxOccurs="unbounded" />
					</xsd:sequence>
				</xsd:complexType>
			</xsd:element>
			<xsd:element name="operationsetResponse">
				<xsd:complexType>
					<xsd:sequence>
						<xsd:element name="operation" type="xsd:string"
							minOccurs="0" maxOccurs="unbounded" />
					</xsd:sequence>
				</xsd:complexType>
			</xsd:element>
			<xsd:complexType name="userRole">
				<xsd:sequence>
					<xsd:element name="username" type="xsd:string"
						minOccurs="1" maxOccurs="1" />
					<xsd:element name="roles" type="xsd:string" minOccurs="1"
						maxOccurs="unbounded" />
				</xsd:sequence>
			</xsd:complexType>
			<xsd:complexType name="userAttribute">
				<xsd:sequence>
					<xsd:element name="value" type="xsd:string" minOccurs="0"
						maxOccurs="1" />
					<xsd:element name="description" type="xsd:string"
						minOccurs="0" maxOccurs="1" />
				</xsd:sequence>
				<xsd:attribute name="name" type="xsd:string" use="required" />
				<xsd:attribute name="mandatory" type="xsd:boolean" />
				<xsd:attribute name="ldapname" type="xsd:string" />
				<xsd:attribute name="inclass" type="xsd:string" />
				<xsd:attribute name="displayname" type="xsd:string" />
			</xsd:complexType>
			<xsd:element name="getFriendsResponse">
				<xsd:complexType>
					<xsd:sequence>
						<xsd:element name="friends" type="tns:friend"
							minOccurs="0" maxOccurs="unbounded" />
					</xsd:sequence>
				</xsd:complexType>
			</xsd:element>
			<xsd:complexType name="friend">
				<xsd:sequence>
					<xsd:element name="username" type="xsd:string"
						minOccurs="1" maxOccurs="1" />
					<xsd:element name="score" type="xsd:integer" minOccurs="1"
						maxOccurs="1" />
				</xsd:sequence>
			</xsd:complexType>
			<xsd:complexType name="userDetail">
				<xsd:sequence>
					<xsd:element name="ePPN" type="xsd:string" minOccurs="1"
						maxOccurs="1" />
					<xsd:element name="name" type="xsd:string" minOccurs="1"
						maxOccurs="1" />
					<xsd:element name="mail" type="xsd:string" minOccurs="0"
						maxOccurs="1" />
					<xsd:element name="organisation" type="xsd:string"
						minOccurs="0" maxOccurs="1" />
					<xsd:element name="agreesearch" type="xsd:boolean"
						minOccurs="0" maxOccurs="1" />
					<xsd:element name="usersupplieddata" type="xsd:boolean"
						minOccurs="0" maxOccurs="1" />
				</xsd:sequence>
			</xsd:complexType>
			<xsd:complexType name="projectInfo">
				<xsd:sequence>
					<xsd:element name="id" type="xsd:string" minOccurs="1"
						maxOccurs="1" />
					<xsd:element name="description" type="xsd:string"
						minOccurs="0" maxOccurs="1" />
					<xsd:element name="name" type="xsd:string" minOccurs="1"
						maxOccurs="1" />
					<xsd:element name="file" type="xsd:string" minOccurs="0"
						maxOccurs="1" />
				</xsd:sequence>
			</xsd:complexType>
			<xsd:element name="authenticationFaultResponse" type="tns:TextGridFaultType" />
			<xsd:element name="unknownProjectFaultResponse" type="tns:TextGridFaultType" />
			<xsd:element name="rbacFaultResponse" type="tns:TextGridFaultType" />
			<xsd:element name="notEmptyFaultResponse" type="tns:TextGridFaultType" />
			<xsd:element name="objectNotFoundFaultResponse" type="tns:TextGridFaultType" />
			<xsd:element name="unknownResourceFaultResponse" type="tns:TextGridFaultType" />
			<xsd:complexType name="TextGridFaultType">
				<xsd:sequence>
					<xsd:element name="faultNo" type="xsd:int" minOccurs="0"
						maxOccurs="1" />
					<xsd:element name="faultMessage" type="xsd:string"
						minOccurs="0" maxOccurs="1" />
					<xsd:element name="cause" type="xsd:string" minOccurs="0"
						maxOccurs="1" />
				</xsd:sequence>
			</xsd:complexType>
		</xsd:schema>
	</wsdl:types>

	<!-- ################################################################### -->
	<!-- ## WSDL-Messages -->
	<!-- ################################################################### -->

	<wsdl:message name="authenticateRequest">
		<wsdl:part element="tns:authenticateRequest" name="authenticateInput" />
	</wsdl:message>
	<wsdl:message name="authenticateResponse">
		<wsdl:part element="tns:authenticateResponse" name="authenticateOutput" />
	</wsdl:message>
	<wsdl:message name="createProjectRequest">
		<wsdl:part element="tns:createProjectRequest" name="createProjectInput" />
	</wsdl:message>
	<wsdl:message name="createProjectResponse">
		<wsdl:part element="tns:createProjectResponse" name="createProjectOutput" />
	</wsdl:message>
	<wsdl:message name="addMemberRequest">
		<wsdl:part element="tns:addMemberRequest" name="addMemberInput" />
	</wsdl:message>
	<wsdl:message name="addMemberResponse">
		<wsdl:part element="tns:booleanResponse" name="addMemberOutput" />
	</wsdl:message>
	<wsdl:message name="deleteMemberRequest">
		<wsdl:part element="tns:deleteMemberRequest" name="deleteMemberInput" />
	</wsdl:message>
	<wsdl:message name="deleteMemberResponse">
		<wsdl:part element="tns:booleanResponse" name="deleteMemberOutput" />
	</wsdl:message>
	<wsdl:message name="tgAddActiveRoleRequest">
		<wsdl:part element="tns:tgAddActiveRoleRequest" name="tgAddActiveRoleInput" />
	</wsdl:message>
	<wsdl:message name="tgAddActiveRoleResponse">
		<wsdl:part element="tns:booleanResponse" name="tgAddActiveRoleOutput" />
	</wsdl:message>
	<wsdl:message name="tgDropActiveRoleRequest">
		<wsdl:part element="tns:tgDropActiveRoleRequest" name="tgDropActiveRoleInput" />
	</wsdl:message>
	<wsdl:message name="tgDropActiveRoleResponse">
		<wsdl:part element="tns:booleanResponse" name="tgDropActiveRoleOutput" />
	</wsdl:message>
	<wsdl:message name="tgGrantPermissionRequest">
		<wsdl:part element="tns:tgGrantPermissionRequest" name="tgGrantPermissionInput" />
	</wsdl:message>
	<wsdl:message name="tgGrantPermissionResponse">
		<wsdl:part element="tns:booleanResponse" name="tgGrantPermissionOutput" />
	</wsdl:message>
	<wsdl:message name="tgRevokePermissionRequest">
		<wsdl:part element="tns:tgRevokePermissionRequest" name="tgRevokePermissionInput" />
	</wsdl:message>
	<wsdl:message name="tgRevokePermissionResponse">
		<wsdl:part element="tns:booleanResponse" name="tgRevokePermissionOutput" />
	</wsdl:message>
	<wsdl:message name="setProjectFileRequest">
		<wsdl:part element="tns:setProjectFileRequest" name="setProjectFileInput" />
	</wsdl:message>
	<wsdl:message name="setProjectFileResponse">
		<wsdl:part element="tns:booleanResponse" name="setProjectFileOutput" />
	</wsdl:message>
	<wsdl:message name="setNameRequest">
		<wsdl:part element="tns:setNameRequest" name="setNameInput" />
	</wsdl:message>
	<wsdl:message name="setNameResponse">
		<wsdl:part element="tns:booleanResponse" name="setNameOutput" />
	</wsdl:message>
	<wsdl:message name="deactivateProjectRequest">
		<wsdl:part element="tns:deactivateProjectRequest" name="deactivateProjectInput" />
	</wsdl:message>
	<wsdl:message name="deactivateProjectResponse">
		<wsdl:part element="tns:booleanResponse" name="deactivateProjectOutput" />
	</wsdl:message>
	<wsdl:message name="reactivateProjectRequest">
		<wsdl:part element="tns:reactivateProjectRequest" name="reactivateProjectInput" />
	</wsdl:message>
	<wsdl:message name="reactivateProjectResponse">
		<wsdl:part element="tns:booleanResponse" name="reactivateProjectOutput" />
	</wsdl:message>
	<wsdl:message name="deleteProjectRequest">
		<wsdl:part element="tns:deleteProjectRequest" name="deleteProjectInput" />
	</wsdl:message>
	<wsdl:message name="deleteProjectResponse">
		<wsdl:part element="tns:booleanResponse" name="deleteProjectOutput" />
	</wsdl:message>
	<wsdl:message name="setMyUserAttributesRequest">
		<wsdl:part element="tns:setMyUserAttributesRequest" name="setMyUserAttributesInput" />
	</wsdl:message>
	<wsdl:message name="setMyUserAttributesResponse">
		<wsdl:part element="tns:booleanResponse" name="setMyUserAttributesOutput" />
	</wsdl:message>
	<wsdl:message name="authenticationFault">
		<wsdl:part element="tns:authenticationFaultResponse" name="authenticationFault" />
	</wsdl:message>
	<wsdl:message name="unknownProjectFault">
		<wsdl:part element="tns:unknownProjectFaultResponse" name="unknownProjectFault" />
	</wsdl:message>
	<wsdl:message name="rbacFault">
		<wsdl:part element="tns:rbacFaultResponse" name="rbacFault" />
	</wsdl:message>
	<wsdl:message name="notEmptyFault">
		<wsdl:part element="tns:notEmptyFaultResponse" name="notEmptyFault" />
	</wsdl:message>
	<wsdl:message name="unknownResourceFault">
		<wsdl:part element="tns:unknownResourceFaultResponse" name="unknownResourceFault" />
	</wsdl:message>
	<wsdl:message name="createProjectInput">
		<wsdl:part name="NewPart" type="xsd:string"></wsdl:part>
	</wsdl:message>

	<!-- ################################################################### -->
	<!-- ## Port-Type-Definitionen -->
	<!-- ################################################################### -->

	<wsdl:portType name="port_tgextra_write">
		<wsdl:operation name="authenticate">
			<wsdl:documentation>
				Internal function used by applications to identify themselves (via
				shared secret between RBAC and WebAuth).
				<ul>
					<li>
						<b>Input Parameters</b>
						authenticateRequest, with elements
						<ul>
							<li>username - String with name of application</li>
							<li>password - String with password for this application</li>
							<li>log - String for log information, optional</li>
						</ul>
					</li>
					<li>
						<b>Output Parameters</b>
						authenticateResponse, with element
						<ul>
							<li>auth - String, SessionID of authenticated application
								(See
								getSid() for format.)</li>
						</ul>
					</li>
					<li>
						<b>Faults</b>
						<ul>
							<li>authenticationFault</li>
						</ul>
					</li>
				</ul>
			</wsdl:documentation>
			<wsdl:input message="tns:authenticateRequest" />
			<wsdl:output message="tns:authenticateResponse" />
			<wsdl:fault name="authenticationFault" message="tns:authenticationFault" />
		</wsdl:operation>
		<wsdl:operation name="createProject">
			<wsdl:documentation>
				Creates a project. Projects are roles with various sub-roles,
				i.e
				Leader, Administrator... Creates default roles with
				default
				permissions:
				<table>
					<tr>
						<td>Role</td>
						<td>Right on Project</td>
					</tr>
					<tr>
						<td>Projektleiter (project leader)</td>
						<td>delegate</td>
					</tr>
					<tr>
						<td>Administrator</td>
						<td>-none-</td>
					</tr>
					<tr>
						<td>Bearbeiter (editor)</td>
						<td>create</td>
					</tr>
					<tr>
						<td>Beobachter (observer)</td>
						<td>-none-</td>
					</tr>
				</table>
				These permissions can be adapted afterwards. For the rights
				on
				resources, see registerResource().
				<ul>
					<li>
						<b>Input Parameters</b>
						createProjectRequest, with elements
						<ul>
							<li>auth - String, SessionID of future project
								leader</li>
							<li>log - String for log information, optional</li>
							<li>name - String with name of project</li>
							<li>description - String with description of
								project</li>
							<li>
								file - String with URI of project file
								-
								<em>currently unused, omit or leave empty and use
									setProjectFile( ) once the file resource has been
									created</em>
							</li>
						</ul>
					</li>
					<li>
						<b>Output Parameters</b>
						createProjectResponse, with element
						<ul>
							<li>projectId - String with the newly assigned project
								ID, such as
								"TGPR123"</li>
						</ul>
					</li>
				</ul>
			</wsdl:documentation>
			<wsdl:input message="tns:createProjectRequest" name="createProjectInput" />
			<wsdl:output message="tns:createProjectResponse" />
		</wsdl:operation>
		<wsdl:operation name="setProjectFile">
			<wsdl:documentation>
				Registers the URI of a TextGridObject to be the project file
				for
				project-specific settings. The URI must be registered at
				RBAC
				beforehand.
				<ul>
					<li>
						<b>Input Parameters</b>
						setProjectFileRequest, with elements
						<ul>
							<li>auth - String, SessionID of Project Leader</li>
							<li>log - String for log information, optional</li>
							<li>project - String with projectID</li>
							<li>file - String with URI of project file</li>
						</ul>
					</li>
					<li>
						<b>Output Parameters</b>
						booleanResponse, with element
						<ul>
							<li>result - boolean, true if operation was successful,
								false
								otherwise</li>
						</ul>
					</li>
					<li>
						<b>Faults</b>
						<ul>
							<li>authenticationFault</li>
						</ul>
					</li>
				</ul>
			</wsdl:documentation>
			<wsdl:input message="tns:setProjectFileRequest" />
			<wsdl:output message="tns:setProjectFileResponse" />
			<wsdl:fault name="authenticationFault" message="tns:authenticationFault" />
		</wsdl:operation>
		<wsdl:operation name="setName">
			<wsdl:documentation>
				Supply user-specific information for display instead of the ePPN.
				<ul>
					<li>
						<b>Input Parameters</b>
						setNameRequest, with elements
						<ul>
							<li>auth - String, SessionID of User who wants to set their name</li>
							<li>log - String for log information, optional</li>
							<li>webAuthSecret - String that is known by the Web
								Authentication which will assure that the data are correct. If
								the secret is not given, the user entry will be marked as a
								volunteered one, where the users gave their details themselves.</li>
							<li>name - String with User Name, preferredly in the form of
								"givenname surname"</li>
							<li>mail - String with User's E-Mail address</li>
							<li>organisation - String with Affiliation of the User</li>
							<li>agreeSerach - Boolean telling whether the user agrees to be
								searchable by the getIDs function.</li>
						</ul>
					</li>
					<li>
						<b>Output Parameters</b>
						booleanResponse, with element
						<ul>
							<li>result - boolean, true if operation was successful,
								false
								otherwise</li>
						</ul>
					</li>
					<li>
						<b>Faults</b>
						<ul>
						</ul>
					</li>
				</ul>
			</wsdl:documentation>
			<wsdl:input message="tns:setNameRequest" />
			<wsdl:output message="tns:setNameResponse" />
		</wsdl:operation>
		<wsdl:operation name="addMember">
			<wsdl:documentation>
				Project leaders can assign users into specific roles. This
				still does
				not effect
				<em>activation</em>
				of the role in the
				user(s)' session(s).
				<ul>
					<li>
						<b>Input Parameters</b>
						addMemberRequest, with elements
						<ul>
							<li>auth - String, SessionID of project leader</li>
							<li>log - String for log information, optional</li>
							<li>username - String with ePPN of user to be added</li>
							<li>role - String with full-qualified role name of the
								role the
								user is to be signed into. The full-qualified
								role name has the
								form
								"Administrator,TGPR3,Projekt-Teilnehmer"</li>
						</ul>
					</li>
					<li>
						<b>Output Parameters</b>
						booleanResponse, with element
						<ul>
							<li>result - boolean, true if operation was successful,
								false
								otherwise</li>
						</ul>
					</li>
					<li>
						<b>Faults</b>
						<ul>
							<li>rbacFault</li>
						</ul>
					</li>
				</ul>
			</wsdl:documentation>
			<wsdl:input message="tns:addMemberRequest" />
			<wsdl:output message="tns:addMemberResponse" />
			<wsdl:fault name="rbacFault" message="tns:rbacFault" />
		</wsdl:operation>
		<wsdl:operation name="deleteMember">
			<wsdl:documentation>
				Project leaders can delete a role from a user. This
				still does not
				effect
				<em>(de-)activation</em>
				of the role in the
				user(s)' session(s).
				<ul>
					<li>
						<b>Input Parameters</b>
						deleteMemberRequest, with elements
						<ul>
							<li>auth - String, SessionID of project leader</li>
							<li>log - String for log information, optional</li>
							<li>username - String with ePPN of user to be signed off</li>
							<li>role - String with full-qualified role name of the
								role the
								user is to be signed off. The full-qualified
								role name has the
								form
								"Administrator,TGPR3,Projekt-Teilnehmer"</li>
						</ul>
					</li>
					<li>
						<b>Output Parameters</b>
						booleanResponse, with element
						<ul>
							<li>result - boolean, true if operation was successful,
								false
								otherwise</li>
						</ul>
					</li>
				</ul>
			</wsdl:documentation>
			<wsdl:input message="tns:deleteMemberRequest" />
			<wsdl:output message="tns:deleteMemberResponse" />
		</wsdl:operation>
		<wsdl:operation name="tgAddActiveRole">
			<wsdl:documentation>
				Activates a role for a session. NB, currently the login
				process
				activates
				<em>all</em>
				available roles of the user.
				<ul>
					<li>
						<b>Input Parameters</b>
						tgAddActiveRoleRequest, with elements
						<ul>
							<li>auth - String, SessionID of user</li>
							<li>log - String for log information, optional</li>
							<li>role - String with full-qualified role name of the
								role the
								user wants to activate. The full-qualified role
								name has the form
								"Administrator,TGPR3,Projekt-Teilnehmer".</li>
						</ul>
					</li>
					<li>
						<b>Output Parameters</b>
						booleanResponse, with element
						<ul>
							<li>result - boolean, true if operation was successful,
								false
								otherwise</li>
						</ul>
					</li>
				</ul>
			</wsdl:documentation>
			<wsdl:input message="tns:tgAddActiveRoleRequest" />
			<wsdl:output message="tns:tgAddActiveRoleResponse" />
		</wsdl:operation>
		<wsdl:operation name="tgDropActiveRole">
			<wsdl:documentation>
				De-activates a role for a session.
				<ul>
					<li>
						<b>Input Parameters</b>
						tgDropActiveRoleRequest, with elements
						<ul>
							<li>auth - String, SessionID of user</li>
							<li>log - String for log information, optional</li>
							<li>role - String with full-qualified role name of the
								role the
								user wants to de-activate. The full-qualified role
								name has the
								form
								"Administrator,TGPR3,Projekt-Teilnehmer".</li>
						</ul>
					</li>
					<li>
						<b>Output Parameters</b>
						booleanResponse, with element
						<ul>
							<li>result - boolean, true if operation was successful,
								false
								otherwise</li>
						</ul>
					</li>
				</ul>
			</wsdl:documentation>
			<wsdl:input message="tns:tgDropActiveRoleRequest" />
			<wsdl:output message="tns:tgDropActiveRoleResponse" />
		</wsdl:operation>
		<wsdl:operation name="tgGrantPermission">
			<wsdl:documentation>
				Enables given operation for given role on given
				resource. Resource
				may be an URI of a TgObject, or
				a projectID. Users need delegate
				right on resource or project
				(i.e. be project leader).
				<ul>
					<li>
						<b>Input Parameters</b>
						tgGrantPermissionRequest, with elements
						<ul>
							<li>auth - String, SessionID of user</li>
							<li>log - String for log information, optional</li>
							<li>role - String with full-qualified role name of the
								role the
								user wants to grant a right. The full-qualified
								role name has the
								form
								"Administrator,TGPR3,Projekt-Teilnehmer".</li>
							<li>operation - String, operation to be granted, such as
								"read",
								"write".</li>
							<li>resource - String, URI of TgObject, or projectID</li>
						</ul>
					</li>
					<li>
						<b>Output Parameters</b>
						booleanResponse, with element
						<ul>
							<li>result - boolean, true if operation was successful,
								false
								otherwise</li>
						</ul>
					</li>
					<li>
						<b>Faults</b>
						<ul>
							<li>authenticationFault</li>
							<li>rbacFault</li>
						</ul>
					</li>
				</ul>
			</wsdl:documentation>
			<wsdl:input message="tns:tgGrantPermissionRequest" />
			<wsdl:output message="tns:tgGrantPermissionResponse" />
			<wsdl:fault name="authenticationFault" message="tns:authenticationFault" />
		</wsdl:operation>
		<wsdl:operation name="tgRevokePermission">
			<wsdl:documentation>
				Disables this permission, see tgGrantPermission for limitations.
				<ul>
					<li>
						<b>Input Parameters</b>
						tgRevokePermissionRequest, with elements
						<ul>
							<li>auth - String, SessionID of user</li>
							<li>log - String for log information, optional</li>
							<li>role - String with full-qualified role name of the
								role the
								user wants to revoke a right. The full-qualified
								role name has
								the form
								"Administrator,TGPR3,Projekt-Teilnehmer".</li>
							<li>operation - String, operation to be granted, such as
								"read",
								"write".</li>
							<li>resource - String, URI of TgObject, or projectID</li>
						</ul>
					</li>
					<li>
						<b>Output Parameters</b>
						booleanResponse, with element
						<ul>
							<li>result - boolean, true if operation was successful,
								false
								otherwise</li>
						</ul>
					</li>
					<li>
						<b>Faults</b>
						<ul>
							<li>authenticationFault</li>
						</ul>
					</li>
				</ul>
			</wsdl:documentation>
			<wsdl:input message="tns:tgRevokePermissionRequest" />
			<wsdl:output message="tns:tgRevokePermissionResponse" />
			<wsdl:fault name="authenticationFault" message="tns:authenticationFault" />
		</wsdl:operation>
		<wsdl:operation name="deactivateProject">
			<wsdl:documentation>
				Hides a project. User must be project leader of the project to
				be
				deactivated. Hidden projects cannot be modified or read
				anymore
				(except published resources). However, information is
				preserved so
				that the project can be re-activated by manual
				modification of the
				database.
				<ul>
					<li>
						<b>Input Parameters</b>
						deactivateProjectRequest, with elements
						<ul>
							<li>auth - String, SessionID of user that wants publish</li>
							<li>log - String for log information, optional</li>
							<li>project - String, ProjectID</li>
						</ul>
					</li>
					<li>
						<b>Output Parameters</b>
						booleanResponse, with element
						<ul>
							<li>result - boolean, true if operation was successful,
								false
								otherwise</li>
						</ul>
					</li>
					<li>
						<b>Faults</b>
						<ul>
							<li>authenticationFault</li>
						</ul>
					</li>
				</ul>
			</wsdl:documentation>
			<wsdl:input message="tns:deactivateProjectRequest" />
			<wsdl:output message="tns:deactivateProjectResponse" />
			<wsdl:fault name="authenticationFault" message="tns:authenticationFault" />
		</wsdl:operation>
		<wsdl:operation name="reactivateProject">
			<wsdl:documentation>
				Reactivate a hidden and deactivated project. The user must be the
				former project leader of the project to be able to reactivate it.
				All rights will be restored.
				<ul>
					<li>
						<b>Input Parameters</b>
						reactivateProjectRequest, with elements
						<ul>
							<li>auth - String, SessionID of user that wants publish</li>
							<li>log - String for log information, optional</li>
							<li>project - String, ProjectID</li>
						</ul>
					</li>
					<li>
						<b>Output Parameters</b>
						booleanResponse, with element
						<ul>
							<li>result - boolean, true if operation was successful,
								false
								otherwise</li>
						</ul>
					</li>
					<li>
						<b>Faults</b>
						<ul>
							<li>authenticationFault</li>
						</ul>
					</li>
				</ul>
			</wsdl:documentation>
			<wsdl:input message="tns:reactivateProjectRequest" />
			<wsdl:output message="tns:reactivateProjectResponse" />
			<wsdl:fault name="authenticationFault" message="tns:authenticationFault" />
			<wsdl:fault name="unknownProjectFault" message="tns:unknownProjectFault" />
		</wsdl:operation>
		<wsdl:operation name="deleteProject">
			<wsdl:documentation>
				Delete a project. User must be project leader of the project that
				is
				deleted. Before a project can be deleted there must not be any
				resources associated with the project. A deleted project cannot be
				restored.
				<ul>
					<li>
						<b>Input Parameters</b>
						deleteProjectRequest, with elements
						<ul>
							<li>auth - String, SessionID of user that wants publish</li>
							<li>log - String for log information, optional</li>
							<li>project - String, ProjectID</li>
						</ul>
					</li>
					<li>
						<b>Output Parameters</b>
						booleanResponse, with element
						<ul>
							<li>result - boolean, true if operation was successful,
								false
								otherwise</li>
						</ul>
					</li>
					<li>
						<b>Faults</b>
						<ul>
							<li>authenticationFault</li>
							<li>notEmptyFault</li>
						</ul>
					</li>
				</ul>
			</wsdl:documentation>
			<wsdl:input message="tns:deleteProjectRequest" />
			<wsdl:output message="tns:deleteProjectResponse" />
			<wsdl:fault name="authenticationFault" message="tns:authenticationFault" />
			<wsdl:fault name="notEmptyFault" message="tns:notEmptyFault" />
		</wsdl:operation>
		<wsdl:operation name="setMyUserAttributes">
			<wsdl:documentation>TODO</wsdl:documentation>
			<wsdl:input message="tns:setMyUserAttributesRequest" />
			<wsdl:output message="tns:setMyUserAttributesResponse" />
			<wsdl:fault name="authenticationFault" message="tns:authenticationFault" />
		</wsdl:operation>
	</wsdl:portType>

	<!-- ################################################################### -->
	<!-- ## Binding -->
	<!-- ################################################################### -->

	<wsdl:binding name="binding_tgextra_write" type="tns:port_tgextra_write">
	<soap:binding style="document" transport="http://schemas.xmlsoap.org/soap/http" />
	<wsdl:operation name="createProject">
		<soap:operation
			soapAction="http://textgrid.info/namespaces/middleware/tgauth-write/createProject" />
		<wsdl:input name="createProjectInput">
			<soap:body use="literal" />
		</wsdl:input>
		<wsdl:output>
			<soap:body use="literal" />
			</wsdl:output>
		</wsdl:operation>
		<wsdl:operation name="setProjectFile">
			<soap:operation
				soapAction="http://textgrid.info/namespaces/middleware/tgauth-write/setProjectFile" />
			<wsdl:input>
				<soap:body use="literal" />
			</wsdl:input>
			<wsdl:output>
				<soap:body use="literal" />
			</wsdl:output>
			<wsdl:fault name="authenticationFault">
				<soap:fault use="literal" name="authenticationFault" />
			</wsdl:fault>
		</wsdl:operation>
		<wsdl:operation name="setName">
			<soap:operation
				soapAction="http://textgrid.info/namespaces/middleware/tgauth-write/setName" />
			<wsdl:input>
				<soap:body use="literal" />
			</wsdl:input>
			<wsdl:output>
				<soap:body use="literal" />
			</wsdl:output>
		</wsdl:operation>
		<wsdl:operation name="addMember">
			<soap:operation
				soapAction="http://textgrid.info/namespaces/middleware/tgauth-write/addMember" />
			<wsdl:input>
				<soap:body use="literal" />
			</wsdl:input>
			<wsdl:output>
				<soap:body use="literal" />
			</wsdl:output>
			<wsdl:fault name="rbacFault">
				<soap:fault use="literal" name="rbacFault" />
			</wsdl:fault>
		</wsdl:operation>
		<wsdl:operation name="deleteMember">
			<soap:operation
				soapAction="http://textgrid.info/namespaces/middleware/tgauth-write/deleteMember" />
			<wsdl:input>
				<soap:body use="literal" />
			</wsdl:input>
			<wsdl:output>
				<soap:body use="literal" />
			</wsdl:output>
		</wsdl:operation>
		<wsdl:operation name="tgAddActiveRole">
			<soap:operation
				soapAction="http://textgrid.info/namespaces/middleware/tgauth-write/tgAddActiveRole" />
			<wsdl:input>
				<soap:body use="literal" />
			</wsdl:input>
			<wsdl:output>
				<soap:body use="literal" />
			</wsdl:output>
		</wsdl:operation>
		<wsdl:operation name="tgDropActiveRole">
			<soap:operation
				soapAction="http://textgrid.info/namespaces/middleware/tgauth-write/tgDropActiveRole" />
			<wsdl:input>
				<soap:body use="literal" />
			</wsdl:input>
			<wsdl:output>
				<soap:body use="literal" />
			</wsdl:output>
		</wsdl:operation>
		<wsdl:operation name="tgGrantPermission">
			<soap:operation
				soapAction="http://textgrid.info/namespaces/middleware/tgauth-write/tgGrantPermission" />
			<wsdl:input>
				<soap:body use="literal" />
			</wsdl:input>
			<wsdl:output>
				<soap:body use="literal" />
			</wsdl:output>
			<wsdl:fault name="authenticationFault">
				<soap:fault use="literal" name="authenticationFault" />
			</wsdl:fault>
		</wsdl:operation>
		<wsdl:operation name="tgRevokePermission">
			<soap:operation
				soapAction="http://textgrid.info/namespaces/middleware/tgauth-write/tgRevokePermission" />
			<wsdl:input>
				<soap:body use="literal" />
			</wsdl:input>
			<wsdl:output>
				<soap:body use="literal" />
			</wsdl:output>
			<wsdl:fault name="authenticationFault">
				<soap:fault use="literal" name="authenticationFault" />
			</wsdl:fault>
		</wsdl:operation>
		<wsdl:operation name="deactivateProject">
			<soap:operation
				soapAction="http://textgrid.info/namespaces/middleware/tgauth-write/deactivateProject" />
			<wsdl:input>
				<soap:body use="literal" />
			</wsdl:input>
			<wsdl:output>
				<soap:body use="literal" />
			</wsdl:output>
			<wsdl:fault name="authenticationFault">
				<soap:fault use="literal" name="authenticationFault" />
			</wsdl:fault>
		</wsdl:operation>
		<wsdl:operation name="reactivateProject">
			<soap:operation
				soapAction="http://textgrid.info/namespaces/middleware/tgauth-write/reactivateProject" />
			<wsdl:input>
				<soap:body use="literal" />
			</wsdl:input>
			<wsdl:output>
				<soap:body use="literal" />
			</wsdl:output>
			<wsdl:fault name="authenticationFault">
				<soap:fault use="literal" name="authenticationFault" />
			</wsdl:fault>
			<wsdl:fault name="unknownProjectFault">
				<soap:fault use="literal" name="unknownProjectFault" />
			</wsdl:fault>
		</wsdl:operation>
		<wsdl:operation name="deleteProject">
			<soap:operation
				soapAction="http://textgrid.info/namespaces/middleware/tgauth-write/deleteProject" />
			<wsdl:input>
				<soap:body use="literal" />
			</wsdl:input>
			<wsdl:output>
				<soap:body use="literal" />
			</wsdl:output>
			<wsdl:fault name="authenticationFault">
				<soap:fault use="literal" name="authenticationFault" />
			</wsdl:fault>
			<wsdl:fault name="notEmptyFault">
				<soap:fault use="literal" name="notEmptyFault" />
			</wsdl:fault>
		</wsdl:operation>
		<wsdl:operation name="setMyUserAttributes">
			<soap:operation
				soapAction="http://textgrid.info/namespaces/middleware/tgauth-write/setMyUserAttributes" />
			<wsdl:input>
				<soap:body use="literal" />
			</wsdl:input>
			<wsdl:output>
				<soap:body use="literal" />
			</wsdl:output>
			<wsdl:fault name="authenticationFault">
				<soap:fault use="literal" name="authenticationFault" />
			</wsdl:fault>
		</wsdl:operation>
		<wsdl:operation name="authenticate">
			<soap:operation
				soapAction="http://textgrid.info/namespaces/middleware/tgauth-write/authenticate" />
			<wsdl:input>
				<soap:body use="literal" />
			</wsdl:input>
			<wsdl:output>
				<soap:body use="literal" />
			</wsdl:output>
			<wsdl:fault name="authenticationFault">
				<soap:fault use="literal" name="authenticationFault" />
			</wsdl:fault>
		</wsdl:operation>
	</wsdl:binding>

	<!-- ################################################################### -->
	<!-- ## Service-Definition -->
	<!-- ################################################################### -->

	<wsdl:service name="tgextra_write">
		<wsdl:port binding="tns:binding_tgextra_write" name="tgextra_write">
			<soap:address location="https://textgridlab.org/dev/tgauth/tgextra-write.php" />
		</wsdl:port>
	</wsdl:service>
</wsdl:definitions>
